## guitarix 0.28.2

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print('Incompatible Waf, use 1.5')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.28.2'
APPNAME='guitarix'

good_faust_versions = ['0.9.43','0.9.46','0.9.55','0.9.58']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):
    
    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')
    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--ldflags',
                    type='string',
                    default='', 
                    dest='ldflags',
                    help='C++ base linker flags ')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')

    comp.add_option('--convolver-ffmpeg',
                    action='store_const',
                    default=False,
                    const=True,
                    help='modified zita-convolver libary that uses ffmpeg instead of fftw3 for FFT (Default NO)')

    comp.add_option('--libdir',
                   type='string',
                   default='', 
                   dest='libdir',
                   help=('library install path '),
                   )

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")

    faust.add_option('--faust-vectorize',
                     action='store_const',
                     default=False,
                     const=True,
                     help="call faust with --vectorize")

    faust.add_option('--faust-vectorize-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help=("call faust with --vectorize for sources built"
                           "in single (float) precision"))

    faust.add_option('--faust-options', help="additional faust options")

    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--no-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help="don't build ladspa plugins (Default yes)")

    ladspa.add_option('--no-new-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build with new ladspa plugins (Default yes)"))


    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    lv2 = opt.add_option_group("LV2 Options (installing LV2 modules)")

    lv2.add_option('--lv2dir',
                    type='string',
                    help='LV2 plugin directory [Default: <prefix>/lib/lv2]')

    lv2.add_option('--no-lv2',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build new lv2 plugins (Default no)"))

    lv2.add_option('--lv2-only',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("build only the lv2 plugins (Default no)"))

    lv2.add_option('--disable-sse',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("disable SSE for lv2 plugins (ARM)"))


    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.sub_options('src/gx_head');


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    if HEXVERSION > 0x10500:
        s = sys.stderr
    else:
        s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.pprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:
        cxxflags.append ("-march=i386")
    elif "i486" in arch:
        cxxflags.append ("-march=i486")
    elif "i586" in arch:
        cxxflags.append ("-march=i586")
    elif "i686" in arch:
        cxxflags.append ("-march=i686")
    else:
        cxxflags.append ("-march=native")

    if "mmx" in x86_flags:
        cxxflags.append ("-mmmx")
    if "3dnow" in x86_flags:
        cxxflags.append ("-m3dnow")

    if "sse5" in x86_flags:
        cxxflags.append ("-msse5")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_2" in x86_flags:
        cxxflags.append ("-msse4.2")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_1" in x86_flags:
        cxxflags.append ("-msse4.1")
        cxxflags.append ("-mfpmath=sse")
    elif "ssse3" in x86_flags:
        cxxflags.append ("-mssse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4a" in x86_flags:
        cxxflags.append ("-msse4a")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4" in x86_flags:
        cxxflags.append ("-msse4")
        cxxflags.append ("-mfpmath=sse")
    elif "sse3" in x86_flags:
        cxxflags.append ("-msse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse2" in x86_flags:
        cxxflags.append ("-msse2")
        cxxflags.append ("-mfpmath=sse")
        #cxxflags.append ("-DUSE_XMMINTRIN")
    elif "sse" in x86_flags:
        cxxflags.append ("-msse")
        cxxflags.append ("-mfpmath=sse")
        # cxxflags.append ("-DUSE_XMMINTRIN")

=== glade-gxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import Options

def set_options(opt):
    grp = opt.get_option_group("--shared-lib")
    grp.add_option('--glade-support',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build support for Glade / GtkBuilder (Developers only!!)'),
                   )
    grp.add_option('--glade-catalog-dir',
                   type='string',
                   default='/usr/share/glade3/catalogs',
                   help='Glade catalog dir [Default: %default]')
    grp.add_option('--glade-modules-dir',
                   type='string',
                   default='/usr/lib/glade3/modules',
                   help='Glade modules dir [Default: %default]')

def configure(conf):
    if Options.options.glade_support:
        conf.env["GX_GLADE_SUPPORT"] = True
        conf.env["GXW_SHARED"] = True
        conf.env["GXW_SHARED_INSTALL"] = True
        conf.env["GLADE_CATALOG_DIR"] = Options.options.glade_catalog_dir
        conf.env["GLADE_MODULES_DIR"] = Options.options.glade_modules_dir

def build(bld):
    if not bld.env["GX_GLADE_SUPPORT"]:
        return
    bld.add_subdirs("glade-icons")
    bld(features = ['cc','cshlib'],
        ccflags = bld.env['CXXFLAGS'],
        uselib = ['GTK2'],
        source = ['glade-gxw.c'],
        target = 'gladegx',
        lib = ["gxw"],
        libpath = bld.path.find_dir("../libgxw/gxw").bldpath(bld.env),
        includes = ['..','../libgxw'],
        install_path = bld.env["GLADE_MODULES_DIR"],
        )

    bld.install_files(bld.env["GLADE_CATALOG_DIR"], "gxw.xml", chmod=0o644)

=== ladspa/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import os

def configure(conf):
    pass

def create_ladspa_plugin(bld, source, target, defstr, uselib = None):
    ladspa_define = target + "=" + defstr

    ladspa_plugin = bld.new_task_gen('cxx', 'shlib')
    ladspa_plugin.env['shlib_PATTERN'] = '%s.so'
    ladspa_plugin.defines  = ladspa_define
    ladspa_plugin.name     = target
    ladspa_plugin.target   = defstr
    ladspa_plugin.source   = source
    ladspa_plugin.env.append_value("CXXFLAGS", ['-fPIC', '-shared'])
    ladspa_plugin.install_path = '${LADSPADIR}'
    ladspa_plugin.chmod = 0o755
    return ladspa_plugin


def build(bld):
    sources = [
        'crybaby.cpp',       
        'distortion.cpp',
        'echo.cpp',      
        'freeverb.cpp',  
        'impulseresponse.cpp',        
        'monoamp.cpp',       
        'monocompressor.cpp',
        'guitarix-ladspa.cpp'           
        ] 

    targets = [
        'crydsp',       
        'distdsp',
        'echodsp',      
        'frdsp',  
        'irdsp',        
        'ampdsp',       
        'comprdsp',
        'mydsp'            
        ] 

    defines = [
        'guitarix_crybaby',       
        'guitarix_distortion',
        'guitarix_echo',      
        'guitarix_freeverb',  
        'guitarix_IR',        
        'guitarix_amp',       
        'guitarix_compressor',
        'guitarix'            
        ] 

    for i in range(0, len(sources)):
        create_ladspa_plugin(bld, sources[i], targets[i], defines[i]) 

    bld.install_files('${SHAREDIR}/ladspa/rdf', 'guitarix.rdf')

=== libgxwmm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def configure(conf):
    conf.sub_config('gxwmm');

def build(bld):
    bld.add_subdirs('gxwmm')
    bld.add_group()
    prog = bld(features = 'cxx cprogram',
               source = 'gxw_demo.cc',
               target = 'gxw_demo',
               uselib = 'GTKMM',
               includes = ['.','../libgxw'],
               install_path = None,
               )
    if bld.env["GX_LIB_SHARED"]:
        prog.libpath = [
            bld.path.find_dir("../libgxw/gxw").bldpath(bld.env),
            bld.path.find_dir("../libgxwmm/gxwmm").bldpath(bld.env)]
        prog.lib = ["gxwmm","gxw"]
    else:
        prog.uselib_local = ['gxwmm','gxw']

=== pixmaps/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import Build

# start each filename with a space
pixmap_files  = ''
pixmap_files += ' gx_on.png'
pixmap_files += ' gx_off.png'  
pixmap_files += ' jackd_on.png'
pixmap_files += ' jackd_off.png'  
pixmap_files += ' gx_bypass.png'  
pixmap_files += ' gx_head.png' 
pixmap_files += ' gx_head-midi.png'
pixmap_files += ' gx_head-warn.png'
pixmap_files += ' gx_log_grey.png'
pixmap_files += ' gx_log_yellow.png'
pixmap_files += ' gx_log_red.png'

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_PIXMAPS_DIR'], pixmap_files, chmod=0o644)

=== rcstyles/wscript ===
#!/usr/bin/env python
# encoding: utf-8

gxstyle_files = [
    'gx12b.png',
    'gx14b.png',
    'gx18.png',
    'gxhead.png',
    'gx_green18.png',
    'gx_black18.png',
    'gx_gree18.png',
    'gx_green1.jpg',
    'gx_green2.jpg',
    'gx_head_gx1-alloy.rc',
    'gx_head_gx2-emerald.rc',
    'gx_head_gx3-dezert.rc',
    'gx_head_gx4-black.rc',
    'gx_head_gx5-gree.rc',
    'gx_head_gx6-blue.rc',
    'gx_head_gx7-blues.rc',
    'gx_head_gx8-dark.rc',
    'gx-dezert_18.png',
    'gx_dezert_12b.png',
    'gx_dezert_14b.png',
    'common.rc',
    'clear.rc',
    'knob9.png',
    'tactile_knob_large_151f.png',
    'tactile_knob_small_99f.png',
    'tactile_knob_medium_151f.png',
    'tactile_switchit_off.png',
    'tactile_switchit_on.png',
    'tactile_wheel_101f.png',
    'tactile_h_wheel_101f.png',
    'tactile_backlit_switchit_off.png',
    'tactile_backlit_switchit_on.png',
    'smallknob9.png',
    'mittleknob9.png',
    'cairo1.jpg',
    'cairo2.jpg',
    'black1.png',
    'black2.png',
    'gx_steal.png',
    'gx_dark.png',
    'stereo.png',
    'bypass.svg',
    'factory.png',
    'mute.svg',
    'readonly.png',
    'scratch.png',
    'versiondiff.png',
    ]

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_STYLE_DIR'], gxstyle_files, chmod=0o644)

=== demos/adv/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006-2009 (ita)

import sys
import Utils, Build, Configure
# advanced tests
# look in src/ for an example of a new compiler that creates cpp files

# the following two variables are used by the target "waf dist"
VERSION='0.0.1'
APPNAME='adv_test'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

# make sure waf has the version we want, note: numbers should contain 2
# periods (as of 1.5.0 --> NOT 1.5)
Utils.waf_version(mini='1.5.0', maxi='1.5.25')

features_str = '''
#include <stdio.h>
int is_big_endian()
{
	long one = 1;
	return !(*((char *)(&one)));
}
int main()
{
	if (is_big_endian()) printf("bigendian=1\\n");
	else printf("bigendian=0\\n");
	printf("int_size=%d\\n", sizeof(int));
	printf("long_int_size=%d\\n", sizeof(long int));
	printf("long_long_int_size=%d\\n", sizeof(long long int));
	printf("double_size=%d\\n", sizeof(double));
	return 0;
}
'''

def check_features(self):

	mp = self.check(fragment=features_str, execute=True)
	try:
		mp = mp.decode('utf-8')
	except:
		pass

	t = Utils.to_hashtable(mp)
	try:
		is_big = int(t['bigendian'])
	except KeyError:
		raise Configure.ConfigurationError('endian test failed %s (see the config.log)' % features_str)

	if is_big: strbig = 'big endian'
	else: strbig = 'little endian'
	self.msg('endianness', strbig)

	self.msg('int size', t['int_size'])
	self.msg('long int size', t['long_int_size'])
	self.msg('long long int size', t['long_long_int_size'])
	self.msg('double size', t['double_size'])

	self.define_cond('IS_BIGENDIAN', is_big)
	self.define_cond('INT_SIZE', int(t['int_size']))
	self.define_cond('LONG_INT_SIZE', int(t['long_int_size']))
	self.define_cond('LONG_LONG_INT_SIZE', int(t['long_long_int_size']))
	self.define_cond('DOUBLE_SIZE', int(t['double_size']))

	return is_big

Configure.conf(check_features) # bind the method


def init(ctx):
	pass
	# redefine the cpp source extensions
	#import cpp
	#cpp.cppobj.s_default_ext = ['.cxx', '.cxy', '.cxyz']

def set_options(opt):
	opt.add_option('--someopt', type='string', help='some option', dest='someopt')
	opt.tool_options('gcc')
	opt.tool_options('g++')
#opt.sub_options('tests')
	# the following is to use after the command-line is parsed:
	# import Options
	# print Options.options.someopt

def configure(conf):
	conf.check_tool('gcc')
	#if not conf.env.CC: conf.fatal('gcc not found')

	conf.check_tool('gas')
	if not conf.env.AS: conf.env.AS = conf.env.CC

	try:
		conf.check_cc(compile_filename='test.s', fragment='''
.text
.align 2

val:
 .long 10

# Multiply input value by 10...
.global mult10
.type mult10, function
mult10:
  movl val,%eax
  imul 4(%esp),%eax
  ret
	''', type='cstaticlib', mandatory=True, msg='Checking for assembler')
	except:
		conf.env.AS = None

	conf.check_tool('g++')
	#if not conf.env.CXX: conf.fatal('g++ not found')

	try: conf.check_tool('flex bison')
	except: pass

	conf.check_tool('misc')
	conf.check_tool('dang', tooldir='.')

	# flags
	conf.check_cxx(cxxflags='-meeh', msg='Checking for flags -meeh') # mandatory=False

	# function
	conf.check(function_name='printf', header_name='stdio.h')
	conf.check(function_name='prontf', header_name='stdio.h')

	# header name
	conf.check(header_name='time.h')
	conf.check(header_name='trme.h')

	# type name
	conf.check(type_name='struct')
	conf.check(type_name='int')

	# code fragment
	conf.check(fragment='int main() {2+2==4;}\n', define_name='boobah')
	conf.check(fragment='uncompilable code', define_name='boobar')

	# libraries, and how to reuse the checks
	conf.check(lib='m')
	conf.check(lib='linux', uselib='M', libpath='/tmp', mandatory=False)

	# something more complicated
	conf.check(
		fragment='#include <stdio.h>\nint main() { printf("%d", sizeof(int)); return 0; }\n',
		define_name ='booeah',
		execute     = True,
		define_ret  = True,
		#quote      = False,
		msg         = 'Checking for sizeof(int)')

	# the demo code, from above
	conf.check_features()

	# frameworks - for OSX
	#conf.check(framework_name='gruik')

	# pkg-config
	conf.check_cfg(atleast_pkgconfig_version='0.0.0')

	conf.check_cfg(package='pango', args='"pango = 1.0.0"')
	conf.check_cfg(package='pango', args='--cflags --libs')
	conf.check_cfg(package='alsa', args='--cflags --libs',
		define_variable={'prefix':'/temp', 'exec_prefix':'/temp'})

	def okmsg(kw):
		# some customization
		return kw['success'].strip()
	conf.check_cfg(package='ORBit-2.0', msg='Checking for program ORBit idl', args='--variable=orbit_idl', okmsg=okmsg)

	# a program
	conf.find_program('cat', var='CAT')

	# c/cxx defines
	conf.define('HAVE_SOMETHING', 1)
	conf.define('TEST_DEFINE', 345)
	conf.env.CXXDEFINES_DEFTEST = ['truc=blah', 'boo']
	conf.env.LIB_CALC = 'fl'

	# finally, write the configuration header
	conf.write_config_header('config.h')

	# set a variant called "default", with another config.h
	env_variant2 = conf.env.copy()
	conf.set_env_name('debug', env_variant2)
	env_variant2.set_variant('debug')

	conf.setenv('debug')
	#conf.env.defines = [] # to remove defines, modify the list held by env.defines
	conf.define('DEBUG', 1)
	conf.define('sep', '\\', quote=True)

	# a few tests
	conf.check(
		fragment='int main() { ',
		define_name = 'AAA',
		execute=True
		)
	conf.check(
		fragment='int main() { return 0; }',
		define_name = 'BBB',
		execute=True
		)
	conf.check(
		fragment='int main() { return 1; }',
		define_name = 'CCC',
		execute=True
		)
	conf.check(
		fragment='#include <stdio.h>\nint main() { printf("hi there");\n return 0; }\n',
		define_name = 'DDD',
		execute=True
		)
	conf.check(
		fragment='#include <stdio.h>\nint main() { printf("hi there");\n return 1; }\n',
		define_name = 'EEE',
		execute=True
		)
	conf.write_config_header('config.h', env=env_variant2)

	# jump to another configuration module
	conf.sub_config('src')

def build(bld):
	"""
	#for debugging or profiling: build empty files

	import Task
	def touch_func(task):
		for x in task.outputs:
			open(x.abspath(task.env), 'w').close()
	for x in Task.TaskBase.classes.keys():
		cls = Task.TaskBase.classes[x]
		cls.func = touch_func
		cls.color = 'CYAN'


	# for kernel-like output
	def custom_str_cc(self):
		return "C: %s\n" % ' '.join([a.nice_path(self.env) for a in self.inputs])
	Task.TaskBase.classes['cc'].display = custom_str_cc

	def custom_str_cc_link(self):
		return "L: %s\n" % ' '.join([a.nice_path(self.env) for a in self.outputs])
	Task.TaskBase.classes['cc_link'].display = custom_str_cc_link
	"""


	# to find files, you may use this:
	#print bld.path.find_iter(flat=True)
	#print bld.path.ant_glob('**/*.c')

	# process subfolders from here
	bld.add_subdirs('src complex variant hybrid')

	# compile the flex+bison test if available
	if bld.env_of_name('default')['FLEX']:
		bld.add_subdirs('bisonflex')
	if bld.env.AS:
		bld.add_subdirs('asm')

=== demos/cc/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006-2010 (ita)

# the following two variables are used by the target "waf dist"
VERSION='0.0.1'
APPNAME='cc_test'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def set_options(opt):
	opt.tool_options('compiler_cc')

def configure(conf):
	conf.check_tool('compiler_cc')

def build(bld):

	# 1. A simple program
	bld(
		features = 'cc cprogram',
		source = bld.path.ant_glob('**/*.c'),
		target = 'test_c_app',
		uselib_local = 'my_static_lib',
		includes = '. /usr/include')

	# 2. A simple static library
	bld(
		features = 'cc cstaticlib',
		source = 'test_staticlib.c',
		target='my_static_lib')

	# note: the syntax bld(...) is equivalent to bld.new_task_gen(...)
	#       instantiates and object of the class task_gen (from the file TaskGen.py)

	# if we had a subfolder we would add the following:
	#bld.add_subdirs('src')

=== demos/cxx/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006 (ita)

# look for a command-line option named 'meow' by using "./waf --help" (where is it defined?)
import Utils
import Options

# VERSION and APPNAME are required by 'waf dist'
VERSION='0.0.1'
APPNAME='cpp_test'

# srcdir is almost always set to '.' except for some proprietary projects where the wscript
# file cannot be found in the top-level; those projects usually provide: srcdir='..'
top = '.'
out = 'build'

def set_options(opt):

	# command-line options provided in a script in a subdirectory named "src"
	opt.sub_options('src')

	# command-line options provided by a waf tool
	opt.tool_options('compiler_cxx')

	# custom command-line options
	opt.add_option('--exe', action='store_true', default=False, help='Execute the program after it is compiled')

	opt.add_option('--build_kind', action='store', default='debug,release', help='build the selected variants')

def configure(conf):

	# conf.env.CXX = Options.options.meow
	# to configure using another compiler, use a command-line like this
	# CXX=g++-3.0 ./waf.py configure will use g++-3.0 instead of 'g++'
	conf.check_tool('compiler_cxx')

	## batched builds can be enabled by including the module optim_cc
	# conf.check_tool('batched_cc')

	conf.sub_config('src')

	# here is how to override flags
	conf.env.CXXFLAGS_MYPROG  = ['-O3']
	if not Utils.is_win32: conf.env.LIB_MYPROG = ['m']
	conf.env.SOME_INSTALL_DIR = '/tmp/ahoy/lib/'

	# create a debug and release builds (variants)
	dbg = conf.env.copy()
	rel = conf.env.copy()

	dbg.set_variant('debug')
	conf.set_env_name('debug', dbg)
	conf.setenv('debug')
	conf.env.CXXFLAGS = ['-D_REENTRANT', '-DDBG_ENABLED', '-Wall', '-O0', '-ggdb3', '-ftemplate-depth-128']

	rel.set_variant('release')
	conf.set_env_name('release', rel)
	conf.setenv('release')
	conf.env.CXXFLAGS = ['-O2']

def build(bld):
	# process subfolders from here
	bld.env.CXXDEPS_MYPROG = '3344539'

	bld.add_subdirs('src app')

	# Examples for installing resources and files when doing './waf install'
	bld.install_files('${PREFIX}/subfolder/subsubfolder', 'src/*.h')
	#bld.install_files('${PREFIX}', 'src/a2.h src/a1.h')
	#install_as('${PREFIX}/dir/bar.png', 'foo.png')

	# enable the debug or the release variant, depending on the one wanted
	for obj in bld.all_task_gen[:]:

		# task generator instances (bld.new_task_gen...) should be created in the same order
		# to avoid unnecessary rebuilds (remember that cloning task generators is cheap, but copying task instances are expensive)
		debug_obj = obj.clone('debug')
		release_obj = obj.clone('release')

		# stupid reminder: do not make clones for the same variant (default -> default)

		# disable the original task generator for the default variant (do not use it)
		obj.posted = 1

		# disable the unwanted variant(s)
		kind = Options.options.build_kind
		if kind.find('debug') < 0:
			debug_obj.posted = 1
		if kind.find('release') < 0:
			release_obj.posted = 1

	# here is how to execute a command when the build finishes
	def post(bld):
		cmd = "PATH=plugins:$PATH LD_LIBRARY_PATH=build/default/src/:$LD_LIBRARY_PATH build/default/src/testprogram"

		# if the custom option is set, execute the program
		if Options.options.exe:
			import os
			os.popen(cmd)

		# in case if more people ask
		#if Options.commands['install']:
		#	try: os.popen("/sbin/ldconfig")
		#	except: pass

	bld.add_post_fun(post)

=== demos/fluid/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Grygoriy Fuchedzhy 2009

top = '.'
out = 'out'

def set_options(opt):
	opt.tool_options('compiler_cxx')

def configure(conf):
	conf.check_tool('compiler_cxx')
	conf.check_tool('fluid')

def build(bld):
	bld(
		features = 'cxx cprogram',
		target   = 'sample',
		source   = 'main.cpp PopupDialog.fl UserInterface.fl',
		includes = '.',
		install_path = '${PREFIX}/bin/',
		uselib = 'FLTK')

=== demos/gnome/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006 (ita)

import os
import intltool, gnome

# the following two variables are used by the target "waf dist"
VERSION='0.0.2'
APPNAME='gnome-test'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def set_options(opt):
	# add your custom options here, for example:
	#opt.add_option('--bunny', type='string', help='how many bunnies we have', dest='bunny')
	pass

def configure(conf):
	conf.check_tool('gcc gnome cs intltool glib2')

	conf.check_cfg(package='gobject-2.0', uselib_store='GOBJECT', atleast_version='2.10.0', args='--cflags --libs', mandatory=True)
	conf.check_cfg(package='libgnome-2.0', uselib_store='GNOME', atleast_version='2.10.0', args='--cflags --libs', mandatory=True)
	conf.check_cfg(package='libgnomeui-2.0', uselib_store='GNOMEUI', atleast_version='2.10.0', mandatory=True, args='--cflags --libs')
	conf.check_cfg(package='gtk+-2.0', uselib_store='GTK', atleast_version='2.6.0', mandatory=True, args='--cflags --libs')
	conf.check_cfg(package='dbus-glib-1', uselib_store='DBUSGLIB', atleast_version='0.60', mandatory=True, args='--cflags --libs')
	conf.check_cfg(package='gtk-sharp-2.0',	uselib_store='GTKSHARP', mandatory=False, args='--cflags --libs')

	#always defined to indicate that i18n is enabled */
	conf.define('ENABLE_NLS', 1)

	#Define to 1 if you have the `bind_textdomain_codeset' function.
	conf.define('HAVE_BIND_TEXTDOMAIN_CODESET', 1)

	#Define to 1 if you have the `dcgettext' function.
	conf.define('HAVE_DCGETTEXT', 1)

	#Define to 1 if you have the <dlfcn.h> header file.
	conf.check(header_name='dlfcn.h', define_name='HAVE_DLFCN_H')

	#Define if the GNU gettext() function is already present or preinstalled.
	conf.define('HAVE_GETTEXT', 1)

	#Define to 1 if you have the <inttypes.h> header file.
	conf.check(header_name='inttypes.h', define_name='HAVE_INTTYPES_H')

	#Define if your <locale.h> file defines LC_MESSAGES.
	#conf.add_define('HAVE_LC_MESSAGES', '1')

	#Define to 1 if you have the <locale.h> header file.
	conf.check(header_name='locale.h', define_name='HAVE_LOCALE_H')

	#Define to 1 if you have the <memory.h> header file.
	conf.check(header_name='memory.h', define_name='HAVE_MEMORY_H')

	#Define to 1 if you have the <stdint.h> header file.
	conf.check(header_name='stdint.h', define_name='HAVE_STDINT_H')

	#Define to 1 if you have the <stdlib.h> header file.
	conf.check(header_name='stdlib.h', define_name='HAVE_STDLIB_H')

	#Define to 1 if you have the <strings.h> header file.
	conf.check(header_name='strings.h', define_name='HAVE_STRINGS_H')

	#Define to 1 if you have the <string.h> header file.
	conf.check(header_name='string.h', define_name='HAVE_STRING_H')

	#Define to 1 if you have the <sys/stat.h> header file.
	conf.check(header_name='sys/stat.h', define_name='HAVE_SYS_STAT_H')

	#Define to 1 if you have the <sys/types.h> header file.
	conf.check(header_name='sys/types.h', define_name='HAVE_SYS_TYPES_H')

	#Define to 1 if you have the <unistd.h> header file.
	conf.check(header_name='unistd.h', define_name='HAVE_UNISTD_H')


	# here is how to add more libraries (look in src/wscript_build too)
	#conf.check_cfg('glib-2.0',            destvar='GLIB',     vnum='2.6.0')
	#conf.check_cfg('libbonobo-2.0',       destvar='BONOBO',   vnum='2.0.0')
	#conf.check_cfg('libbonoboui-2.0',     destvar='BONOBOUI', vnum='2.0.0')
	#conf.check_cfg('libglade-2.0',        destvar='GLADE',    vnum='2.0.1')
	#conf.check_cfg('libgnomecanvas-2.0',  destvar='CANVAS',   vnum='2.0.1')
	#conf.check_cfg('libgnomeprintui-2.2', destvar='PRINTUI',  vnum='2.2.0')
	#conf.check_cfg('libgnomeprint-2.2',   destvar='PRINT',    vnum='2.2.0')
	#conf.check_cfg('libxml-2.0',          destvar='XML',      vnum='2.4.23')
	#conf.check_cfg('gdk-x11-2.0',         destvar='GDK',      vnum='1.0.0')

	conf.define('VERSION', VERSION)
	conf.define('GETTEXT_PACKAGE', 'gnome-hello-2.0')
	conf.define('PACKAGE', 'gnome-hello')

	conf.env.append_value('CCFLAGS', '-DHAVE_CONFIG_H')

	conf.env.ASSEMBLIES_GLIB = '/usr/lib/mono/gtk-sharp/glib-sharp.dll'

	conf.write_config_header('config.h')

def build(bld):
	# process subfolders from here
	bld.add_subdirs('src mkenums marshal pixmaps')

	env = bld.env
	if env.XML2PO and env.XSLTPROC2PO:
		bld.add_subdirs('help')

	if env.INTLTOOL:
		bld.add_subdirs('po data')

	if env.HAVE_GTKSHARP and env.MCS:
		bld.add_subdirs('sharp')

	#if env.SGML2MAN:
	#	bld.add_subdirs('man')

	def post(ctx):
		# Postinstall tasks:
		gnome.postinstall_scrollkeeper('gnome-hello') # Installing the user docs
		gnome.postinstall_schemas('gnome-test') # Installing GConf schemas
		gnome.postinstall_icons() # Updating the icon cache

	bld.add_post_fun(post)

=== demos/goexample/wscript ===
#!/usr/bin/env python
# encoding: utf-8
# grt - Go Ray Tracer
# By: Tom Wambold <tom5760@gmail.com>
# wscript - Waf build script

top = '.'
out = 'build'

def set_options(opt):
	opt.add_option('--exe', action='store_true', default=False, help='Execute the program after it is compiled', dest='exe')

def configure(ctx):
	ctx.check_tool('go')

	try:
		ctx.check_tool('gcc')
		ctx.check_cc(fragment='#include <gmp.h>\nint main() {return 0;}\n', uselib_store='GMP', lib='gmp')
	except ctx.errors.ConfigurationError:
		ctx.env.TRY_CGO = False
	else:
		ctx.env.TRY_CGO = True

def build(ctx):
	ctx(
		features = 'go gopackage',
		target   = 'other',
		source   = [
			'other/a.go',
			'other/b.go',
		],
	)

	ctx(
		features = 'go goprogram',
		target   = 'test',
		uselib_local = 'other',
		source   = 'main.go',
	)

	if ctx.env.TRY_CGO:
		# see http://code.google.com/p/go/issues/detail?id=533
		# so we have to move the files, grrrrr
		ctx(name='cgo', rule='${CGO} ${SRC[0].abspath(env)} && mv ../../gmp.cgo1.go ../../gmp.cgo2.c ${TGT[0].parent.abspath(env)}',
			target='gmp.cgo1.go gmp.cgo2.c   gmp.cgo2.c _cgo_gotypes.go _cgo_defun.c',
			source='gmp.go',
			cwd = ctx.path.abspath(ctx.env),
			shell=True)
		ctx.add_group()
		ctx(features='cc cshlib', source='gmp.cgo2.c', target='cgo_gmp.so', uselib='GMP')
		ctx.add_group()
		ctx(features='go goprogram', source='pi.go', target='pi')


	import Options, Utils
	if ctx.env.TRY_CGO and Options.options.exe:
		def exe(bld):
			p = Utils.subprocess.Popen('LD_LIBRARY_PATH=build ./build/pi', shell=True)
			p.wait()
		ctx.add_post_fun(exe)

=== debian/changelog ===
guitarix (0.28.2-4) unstable; urgency=low

  * debian/control:
    - Standards-Version: 3.9.5
    - Drop libboost-foo1.53-dev alternatives from build-depends to
      fix boost transition (Closes: #731020)

 -- Roland Stigge <stigge@antcom.de>  Sun, 01 Dec 2013 11:02:29 +0100

guitarix (0.28.2-3) unstable; urgency=low

  * debian/control: vorbistools -> vorbis-tools (Closes: #719170)

 -- Roland Stigge <stigge@antcom.de>  Fri, 09 Aug 2013 22:02:47 +0200

guitarix (0.28.2-2) unstable; urgency=low

  * Added upstream patch to fix build on Hurd/freebsd

 -- Roland Stigge <stigge@antcom.de>  Wed, 07 Aug 2013 21:46:58 +0200

guitarix (0.28.2-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Mon, 05 Aug 2013 22:41:16 +0200

guitarix (0.28.1-2) unstable; urgency=low

  * Added upstream patch to fix build problem on hurd

 -- Roland Stigge <stigge@antcom.de>  Fri, 02 Aug 2013 21:11:49 +0200

guitarix (0.28.1-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sun, 28 Jul 2013 19:43:10 +0200

guitarix (0.27.1-3) unstable; urgency=low

  * Reorder Build-Depends: since buildd only consider the first one in
    alternatives (Closes: #707723)

 -- Roland Stigge <stigge@antcom.de>  Fri, 10 May 2013 21:27:17 +0200

guitarix (0.27.1-2) unstable; urgency=low

  * Fix build with gcc-4.8 via new libboost >= 1.53 (Closes: #701293)

 -- Roland Stigge <stigge@antcom.de>  Thu, 09 May 2013 14:10:55 +0200

guitarix (0.27.1-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sun, 05 May 2013 14:00:10 +0200

guitarix (0.25.2-2) experimental; urgency=low

  * debian/control:
    - Fixed package description, thanks to Omar Campagne (Closes: #688570)
    - Standards-Version: 3.9.4
    - Build-Depends: debhelper (>= 9), version to be consistent with
      debian/compat

 -- Roland Stigge <stigge@antcom.de>  Fri, 15 Mar 2013 18:36:42 +0100

guitarix (0.25.2-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sat, 09 Feb 2013 10:10:32 +0100

guitarix (0.25.1-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sun, 06 Jan 2013 14:36:36 +0100

guitarix (0.24.3-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 15 Nov 2012 10:18:29 +0100

guitarix (0.24.2-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sat, 20 Oct 2012 10:34:27 +0200

guitarix (0.24.1-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sun, 14 Oct 2012 20:40:31 +0200

guitarix (0.24.0-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Mon, 13 Aug 2012 10:55:42 +0200

guitarix (0.23.3-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 02 Aug 2012 17:57:39 +0200

=== debian/control ===
Source: guitarix
Section: sound
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), python, libjack-dev, libsndfile1-dev, libgtk2.0-dev, ladspa-sdk, libzita-convolver-dev, libgtkmm-2.4-dev, libboost-dev (>= 1.53), libboost-thread-dev (>= 1.53), intltool, liblrdf0-dev, libboost-system-dev (>= 1.53), lv2-dev, libavahi-gobject-dev
Standards-Version: 3.9.5
Homepage: http://guitarix.sourceforge.net/

Package: guitarix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines, gtk2-engines-pixbuf
Recommends: jack-capture, vorbis-tools, lame
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for Jack (Jack Audio Connection Kit) with
 one input and two outputs. It is designed to get nice trash/metal/rock/guitar
 sounds.  Controls are available for bass, treble, gain, balance, distortion,
 freeverb, crybaby(wah) and echo. For the 'pressure' in the sound you can use
 the feedback and feedforward sliders. guitarix comes with a GTK interface and
 as Ladspa plugin.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	./waf configure --prefix=/usr --no-faust \
		--cxxflags="$(shell dpkg-buildflags --get CXXFLAGS) \
			$(shell dpkg-buildflags --get CPPFLAGS)" \
		--ldflags="$(shell dpkg-buildflags --get LDFLAGS)" -v

override_dh_auto_build:
	./waf build -v

override_dh_auto_clean: 
	./waf distclean
	rm -rf build/*
	rm -rf build/.conf*
	rm -rf build/.waf*
	find . -name "*.pyc" -delete

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/guitarix
	rm -f $(CURDIR)/debian/guitarix/usr/share/gx_head/sounds/bands/LICENSE
	rm -f $(CURDIR)/debian/guitarix/usr/share/gx_head/sounds/amps/LICENSE
	rm -f $(CURDIR)/debian/guitarix/usr/lib/libgxw.so
	rm -f $(CURDIR)/debian/guitarix/usr/lib/libgxwmm.so

=== debian/watch ===
version=3
http://sf.net/guitarix/guitarix.?-(.*)\.tar\.bz2
